From 06f0aabc228a36ead8b1ab1cfdad66b3b609daf9 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Apr 11 2017 12:51:54 +0000
Subject: [PATCH 815/1001] Add tests


...and un-skip the existing unit tests.

---

diff --git a/hubs/app.py b/hubs/app.py
index 7b28c4c..d50c365 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -65,12 +65,6 @@ def commas(numeric):
     return "{:,.2f}".format(numeric)
 
 
-@app.teardown_request
-def shutdown_session(exception=None):
-    """ Remove the DB session at the end of each request. """
-    session.remove()
-
-
 # Set up OpenIDConnect
 OIDC = OpenIDConnect(app, credentials_store=flask.session)
 
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index edd2ba5..ad600c0 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -1,17 +1,17 @@
 from __future__ import unicode_literals
 
-from contextlib import contextmanager
 import json
-from datetime import datetime, timedelta
 import os
-
-import munch
-from flask import template_rendered
-from os.path import dirname
 import unittest
+from contextlib import contextmanager
+from datetime import datetime, timedelta
+from os.path import dirname
 
+import flask
+import munch
 import requests
 import vcr
+from flask.signals import template_rendered
 
 import hubs.models
 
@@ -99,6 +99,21 @@ class APPTest(unittest.TestCase):
             raise IOError("Failed to talk to %r %r" % (response.url, response))
         return response.json()
 
+    def check_url(self, url, user=None, code=200):
+        with auth_set(hubs.app.app, user):
+            with hubs.app.app.app_context():
+                with captured_templates(flask.current_app) as templates:
+                    response = self.app.get(url)
+        self.assertEqual(response.status_code, code)
+        if templates:
+            self.assertEqual(len(templates), 1)
+            template, context = templates[0]
+        else:
+            template = context = None
+        response.context = context
+        response.template = template
+        return response
+
 
 @contextmanager
 def auth_set(APP, auth):
diff --git a/hubs/tests/hubs_test.cfg b/hubs/tests/hubs_test.cfg
index 66ccd47..a910e72 100644
--- a/hubs/tests/hubs_test.cfg
+++ b/hubs/tests/hubs_test.cfg
@@ -9,3 +9,5 @@ DB_URL = 'sqlite:///%s/test.db' % (os.path.dirname(os.path.abspath(__file__)))
 import os
 OIDC_CLIENT_SECRETS = os.path.join(os.path.dirname(
     os.path.abspath(__file__)), 'client_secrets.json')
+
+SITE_ADMINS = ["admin"]
diff --git a/hubs/tests/test_authz.py b/hubs/tests/test_authz.py
new file mode 100644
index 0000000..ec607de
--- /dev/null
+++ b/hubs/tests/test_authz.py
@@ -0,0 +1,113 @@
+from __future__ import absolute_import, unicode_literals
+
+from hubs.authz import ObjectAuthzMixin, AccessLevel, PERMISSIONS
+from hubs.tests import APPTest, FakeAuthorization
+
+
+class TestObj(ObjectAuthzMixin):
+
+    def __init__(self, roles=None):
+        self.roles = roles or {}
+
+    def _get_auth_group(self):
+        return "auth-group"
+
+    def _get_auth_user_roles(self, user):
+        return self.roles
+
+
+class AuthzTestCase(APPTest):
+
+    def run(self, *args, **kwargs):
+        import hubs.app
+        with hubs.app.app.app_context():
+            super(AuthzTestCase, self).run(*args, **kwargs)
+
+    def test_mixin_access_level_anonymous(self):
+        obj = TestObj()
+        self.assertEqual(
+            obj._get_auth_access_level(None), AccessLevel.anonymous)
+
+    def test_mixin_access_level_logged_in(self):
+        obj = TestObj()
+        user = FakeAuthorization('ralph')
+        self.assertEqual(
+            obj._get_auth_access_level(user), AccessLevel.logged_in)
+
+    def test_mixin_group_access_level(self):
+        obj = TestObj(roles={"auth-group": "member"})
+        user = FakeAuthorization('ralph')
+        self.assertEqual(
+            obj._get_auth_access_level(user), AccessLevel.member)
+
+    def test_mixin_group_access_level_no_role(self):
+        obj = TestObj(roles={"unrelated-group": "member"})
+        user = FakeAuthorization('ralph')
+        self.assertEqual(
+            obj._get_auth_access_level(user), AccessLevel.logged_in)
+
+    def test_mixin_group_access_level_unsupported(self):
+        obj = TestObj(roles={"auth-group": "dark_lord"})
+        user = FakeAuthorization('ralph')
+        self.assertEqual(
+            obj._get_auth_access_level(user), AccessLevel.logged_in)
+
+    def test_allows_anonymous(self):
+        obj = TestObj()
+        self.assertTrue(obj.allows(None, 'hub.public.view'))
+        self.assertTrue(obj.allows(None, 'hub.preview.view'))
+        self.assertFalse(obj.allows(None, 'hub.private.view'))
+        self.assertFalse(obj.allows(None, 'hub.users.manage'))
+        self.assertFalse(obj.allows(None, 'hub.config'))
+        self.assertTrue(obj.allows(None, 'widget.public.view'))
+        self.assertFalse(obj.allows(None, 'widget.restricted.view'))
+
+    def test_allows_logged_in(self):
+        user = FakeAuthorization('ralph')
+        obj = TestObj()
+        self.assertTrue(obj.allows(user, 'hub.public.view'))
+        self.assertTrue(obj.allows(user, 'hub.preview.view'))
+        self.assertFalse(obj.allows(user, 'hub.private.view'))
+        self.assertFalse(obj.allows(user, 'hub.users.manage'))
+        self.assertFalse(obj.allows(user, 'hub.config'))
+        self.assertTrue(obj.allows(user, 'widget.public.view'))
+        self.assertTrue(obj.allows(user, 'widget.restricted.view'))
+
+    def test_allows_member(self):
+        user = FakeAuthorization('ralph')
+        obj = TestObj(roles={"auth-group": "member"})
+        self.assertTrue(obj.allows(user, 'hub.public.view'))
+        self.assertTrue(obj.allows(user, 'hub.preview.view'))
+        self.assertTrue(obj.allows(user, 'hub.private.view'))
+        self.assertFalse(obj.allows(user, 'hub.users.manage'))
+        self.assertFalse(obj.allows(user, 'hub.config'))
+        self.assertTrue(obj.allows(user, 'widget.public.view'))
+        self.assertTrue(obj.allows(user, 'widget.restricted.view'))
+
+    def test_allows_sponsor(self):
+        user = FakeAuthorization('ralph')
+        obj = TestObj(roles={"auth-group": "sponsor"})
+        self.assertTrue(obj.allows(user, 'hub.public.view'))
+        self.assertTrue(obj.allows(user, 'hub.preview.view'))
+        self.assertTrue(obj.allows(user, 'hub.private.view'))
+        self.assertTrue(obj.allows(user, 'hub.users.manage'))
+        self.assertFalse(obj.allows(user, 'hub.config'))
+        self.assertTrue(obj.allows(user, 'widget.public.view'))
+        self.assertTrue(obj.allows(user, 'widget.restricted.view'))
+
+    def test_allows_owner(self):
+        user = FakeAuthorization('ralph')
+        obj = TestObj(roles={"auth-group": "owner"})
+        self.assertTrue(obj.allows(user, 'hub.public.view'))
+        self.assertTrue(obj.allows(user, 'hub.preview.view'))
+        self.assertTrue(obj.allows(user, 'hub.private.view'))
+        self.assertTrue(obj.allows(user, 'hub.users.manage'))
+        self.assertTrue(obj.allows(user, 'hub.config'))
+        self.assertTrue(obj.allows(user, 'widget.public.view'))
+        self.assertTrue(obj.allows(user, 'widget.restricted.view'))
+
+    def test_allows_site_admin(self):
+        user = FakeAuthorization('admin')
+        obj = TestObj()
+        for perm in PERMISSIONS.keys():
+            self.assertTrue(obj.allows(user, perm))
diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index 29b91fc..a0a0d62 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -14,6 +14,7 @@ import hubs.models
 
 
 class HubsAPITest(hubs.tests.APPTest):
+
     def test_index_logged_out(self):
         result = self.app.get('/', follow_redirects=False)
         self.assertEqual(result.status_code, 302)
@@ -65,6 +66,29 @@ class HubsAPITest(hubs.tests.APPTest):
                 'Not logged in.  Click to <a href="/login">login</a>',
                 result.get_data(as_text=True))
 
+    def test_hub_preview(self):
+        hub = hubs.models.Hub.by_name('ralph')
+        hub.config.visibility = "preview"
+        # Preview hubs are accessible to anonymous users (but some
+        # widgets may be restricted).
+        with tests.auth_set(app, None):
+            result = self.app.get('/ralph', follow_redirects=True)
+            self.assertEqual(result.status_code, 200)
+
+    def test_hub_private(self):
+        hub = hubs.models.Hub.by_name('ralph')
+        hub.config.visibility = "private"
+        self.session.commit()
+        # Private hubs are not accessible to anonymous users.
+        with tests.auth_set(app, None):
+            result = self.app.get('/ralph', follow_redirects=True)
+            self.assertEqual(result.status_code, 403)
+        # But they are accessible to members.
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph', follow_redirects=True)
+            self.assertEqual(result.status_code, 200)
+
     def test_hub_json(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
@@ -80,6 +104,7 @@ class HubsAPITest(hubs.tests.APPTest):
                 'chat_domain': None,
                 "left_width": 8,
                 "summary": "Ralph",
+                "visibility": "public",
             },
             "members": ["ralph"],
             "name": "ralph",
@@ -89,46 +114,49 @@ class HubsAPITest(hubs.tests.APPTest):
         }
         self.assertDictEqual(data, json.loads(result.get_data(as_text=True)))
 
-    @unittest.skip("Authorization layer not present yet")
+    def test_hub_private_json(self):
+        hub = hubs.models.Hub.by_name('ralph')
+        hub.config.visibility = "private"
+        self.session.commit()
+        # Private hubs are not accessible to anonymous users.
+        with tests.auth_set(app, None):
+            result = self.app.get('/ralph/json', follow_redirects=True)
+            self.assertEqual(result.status_code, 403)
+        # But they are accessible to members.
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph/json', follow_redirects=True)
+            self.assertEqual(result.status_code, 200)
+
     def test_hub_edit_get_logged_out(self):
-        # FAILING: Authorization layer not present yet
         with tests.auth_set(app, None):
-            result = self.app.get('/ralph/edit', follow_redirects=True)
-            self.assertEqual(result.status_code, 403)  # failing right
-            # We do not have the authorization layer in place yet
+            result = self.app.get('/ralph/edit', follow_redirects=False)
+        self.assertEqual(result.status_code, 302)
+        self.assertEqual(urlparse(result.location).path, "/login")
 
-    @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_get_logged_in_not_owner(self):
-        # FAILING: Authorization layer not present yet
         user = tests.FakeAuthorization('not_ralph')
         with tests.auth_set(app, user):
             result = self.app.get('/ralph/edit', follow_redirects=True)
-            self.assertEqual(result.status_code, 403)  # failing right
-            # We do not have the authorization layer in place yet
+            self.assertEqual(result.status_code, 403)
 
     def test_hub_edit_get_logged_in_owner(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             result = self.app.get('/ralph/edit', follow_redirects=True)
             self.assertEqual(result.status_code, 200)
-            # We do not have the authorization layer so everyone can edit
 
-    @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_post_logged_out(self):
-        # FAILING: Authorization layer not present yet
         with tests.auth_set(app, None):
-            result = self.app.post('/ralph/edit', follow_redirects=True)
-            self.assertEqual(result.status_code, 403)  # failing right
-            # We do not have the authorization layer in place yet
+            result = self.app.post('/ralph/edit', follow_redirects=False)
+        self.assertEqual(result.status_code, 302)
+        self.assertEqual(urlparse(result.location).path, "/login")
 
-    @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_post_logged_in_not_owner(self):
-        # FAILING: Authorization layer not present yet
         user = tests.FakeAuthorization('not_ralph')
         with tests.auth_set(app, user):
             result = self.app.post('/ralph/edit', follow_redirects=True)
-            self.assertEqual(result.status_code, 403)  # failing right
-            # We do not have the authorization layer in place yet
+            self.assertEqual(result.status_code, 403)
 
     def test_hub_edit_post_logged_in_owner_empty_data(self):
         user = tests.FakeAuthorization('ralph')
@@ -303,10 +331,10 @@ class HubsAPITest(hubs.tests.APPTest):
             expected_str = '/ralph/37/edit'
             self.assertIn(expected_str, result.get_data(as_text=True))
 
-    @unittest.skip("Authorization layer not present yet")
     def test_hub_edit_widget_get_logged_out(self):
-        result = self.app.get('/ralph/31/edit', follow_redirects=True)
-        self.assertEqual(result.status_code, 403)
+        result = self.app.get('/ralph/31/edit', follow_redirects=False)
+        self.assertEqual(result.status_code, 302)
+        self.assertEqual(urlparse(result.location).path, "/login")
 
     def test_hub_edit_widget_post_empty_data_logged_in(self):
         user = tests.FakeAuthorization('ralph')
@@ -411,10 +439,12 @@ class HubsAPITest(hubs.tests.APPTest):
                     ),
                 "chat_channel": None,
                 "chat_domain": None,
+                "visibility": "public",
             },
             "general": {
                 "chat_networks": app.config["CHAT_NETWORKS"],
                 "roles": ["owner", "member"],
+                "hub_visibility": hubs.models.HubConfig.VISIBILITY,
             },
             "users": {
                 "member": [],
@@ -484,8 +514,14 @@ class HubsAPITest(hubs.tests.APPTest):
             "Unsupported chat domain."
             )
 
-    @unittest.skip("Authorization layer not present yet")
-    def test_hub_config_unauthorized(self):
+    def test_hub_config_get_unauthorized(self):
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            url = '/decause/config'
+            result = self.app.get(url)
+        self.assertEqual(result.status_code, 403)
+
+    def test_hub_config_post_unauthorized(self):
         user = tests.FakeAuthorization('ralph')
         with tests.auth_set(app, user):
             url = '/decause/config?category=config'
diff --git a/hubs/tests/test_models.py b/hubs/tests/test_models.py
index c3279cd..d6cc11c 100644
--- a/hubs/tests/test_models.py
+++ b/hubs/tests/test_models.py
@@ -1,9 +1,11 @@
 from __future__ import unicode_literals
 
+import fedmsg.config
+
 import hubs
 import hubs.models
 import hubs.tests
-import fedmsg.config
+from hubs.authz import AccessLevel
 
 fedmsg_config = fedmsg.config.load_config()
 
@@ -153,3 +155,81 @@ class ModelTest(hubs.tests.APPTest):
                           session=self.session,
                           username=username,
                           visited_hub=hub)
+
+    def test_auth_hub_widget_access_level(self):
+        username = 'ralph'
+        ralph = hubs.models.User.get(username)
+        hub_ralph = hubs.models.Hub.get(username)
+        widget_ralph = hubs.models.Widget.query.filter_by(
+            hub=hub_ralph, plugin="contact").one()
+        hub_decause = hubs.models.Hub.get("decause")
+        widget_decause = hubs.models.Widget.query.filter_by(
+            hub=hub_decause, plugin="contact").one()
+        self.assertEqual(
+            hub_decause._get_auth_access_level(ralph),
+            AccessLevel.logged_in)
+        self.assertEqual(
+            widget_decause._get_auth_access_level(ralph),
+            AccessLevel.logged_in)
+        self.assertEqual(
+            hub_ralph._get_auth_access_level(ralph),
+            AccessLevel.owner)
+        self.assertEqual(
+            widget_ralph._get_auth_access_level(ralph),
+            AccessLevel.owner)
+
+    def test_auth_hub_auth_group(self):
+        username = "ralph"
+        hub = hubs.models.Hub.get(username)
+        self.assertEqual(hub._get_auth_group(), username)
+        # Uncomment this when CAIAPI is active.
+        # hub.config.auth_group = "testing"
+        # self.assertEqual(hub._get_auth_group(), "testing")
+
+    def test_auth_hub_permission_name(self):
+        hub = hubs.models.Hub.get("ralph")
+        self.assertEqual(
+            hub._get_auth_permission_name("view"), "hub.public.view")
+        self.assertEqual(
+            hub._get_auth_permission_name("users.manage"), "hub.users.manage")
+        self.assertEqual(
+            hub._get_auth_permission_name("config"), "hub.config")
+        hub.config.visibility = "preview"
+        self.assertEqual(
+            hub._get_auth_permission_name("view"), "hub.preview.view")
+        hub.config.visibility = "private"
+        self.assertEqual(
+            hub._get_auth_permission_name("view"), "hub.private.view")
+
+    def test_auth_hub_widget_user_roles(self):
+        username = "ralph"
+        ralph = hubs.models.User.get(username)
+        hub = hubs.models.Hub.get(username)
+        widget = hubs.models.Widget.query.filter_by(
+            hub=hub, plugin="contact").one()
+        assert len(hub.associations) == 1
+        assert hub.associations[0].user.username == "ralph"
+        for role in ["owner", "sponsor", "member"]:
+            hub.associations[0].role = role
+            self.assertEqual(
+                hub._get_auth_user_roles(ralph), {"ralph": role})
+            self.assertEqual(
+                widget._get_auth_user_roles(ralph), {"ralph": role})
+
+    def test_auth_widget_permission_name(self):
+        hub = hubs.models.Hub.get("ralph")
+        widget = hubs.models.Widget.query.filter_by(
+            hub=hub, plugin="contact").one()
+        self.assertEqual(
+            widget._get_auth_permission_name("view"), "hub.public.view")
+        hub.config.visibility = "private"
+        self.session.commit()
+        self.assertEqual(
+            widget._get_auth_permission_name("view"), "hub.private.view")
+        hub.config.visibility = "preview"
+        assert widget.visibility == "public"
+        self.assertEqual(
+            widget._get_auth_permission_name("view"), "widget.public.view")
+        widget.visibility = "restricted"
+        self.assertEqual(
+            widget._get_auth_permission_name("view"), "widget.restricted.view")
diff --git a/hubs/tests/test_view_utils.py b/hubs/tests/test_view_utils.py
index d5e8218..0101299 100644
--- a/hubs/tests/test_view_utils.py
+++ b/hubs/tests/test_view_utils.py
@@ -1,11 +1,11 @@
 from __future__ import unicode_literals
 
 import hubs.models
-import hubs.tests
+from hubs.tests import APPTest, FakeAuthorization, auth_set
 from hubs.views.utils import get_visible_widgets
 
 
-class ModelTest(hubs.tests.APPTest):
+class ViewUtilsTest(APPTest):
 
     def test_removed_widget(self):
         hub = hubs.models.Hub.get("ralph")
@@ -13,8 +13,7 @@ class ModelTest(hubs.tests.APPTest):
             hub=hub, plugin="does-not-exist",
             left=True, index=-1, _config="{}")
         self.session.add(widget)
-        user = hubs.tests.FakeAuthorization('ralph')
-        with hubs.tests.auth_set(self.app.application, user):
+        with auth_set(self.app.application, FakeAuthorization('ralph')):
             with self.app.application.app_context():
                 widgets = get_visible_widgets(hub)
         self.assertNotIn(
@@ -22,3 +21,62 @@ class ModelTest(hubs.tests.APPTest):
         widget.left = False
         self.assertNotIn(
             "does-not-exist", [w.plugin for w in widgets["right"]])
+
+    def test_get_visible_widgets(self):
+        hub = hubs.models.Hub.get('ralph')
+        with auth_set(self.app.application, None):
+            with self.app.application.app_context():
+                widgets = get_visible_widgets(hub)
+        self.assertListEqual(
+            [w.plugin for w in widgets["left"]],
+            ["feed"])
+        self.assertListEqual(
+            [w.plugin for w in widgets["right"]],
+            ['contact', 'meetings', 'fedmsgstats', 'workflow.updates2stable',
+             'workflow.pendingacls', 'subscriptions', 'badges', 'pagure_pr',
+             'github_pr', 'bugzilla', 'halp', 'about']
+            )
+
+    def test_get_visible_widgets_preview(self):
+        hub = hubs.models.Hub.by_name('ralph')
+        hub.config.visibility = "preview"
+        meetings = hubs.models.Widget.query.filter_by(
+            hub=hub, plugin="meetings").first()
+        # make sure the test is valid
+        assert meetings.left is False
+        # set the widget to "restricted"
+        meetings.visibility = "restricted"
+        # Restricted widgets in preview hubs aren't displayed to
+        # anonymous users.
+        with auth_set(self.app.application, None):
+            with self.app.application.app_context():
+                widgets = get_visible_widgets(hub)
+        self.assertNotIn(
+            "meetings", [w.plugin for w in widgets["right"]])
+        # But they are displayed to members.
+        with auth_set(self.app.application, FakeAuthorization('ralph')):
+            with self.app.application.app_context():
+                widgets = get_visible_widgets(hub)
+        self.assertIn(
+            "meetings", [w.plugin for w in widgets["right"]])
+
+    def test_get_visible_widgets_private(self):
+        hub = hubs.models.Hub.by_name('ralph')
+        hub.config.visibility = "private"
+        meetings = hubs.models.Widget.query.filter_by(
+            hub=hub, plugin="meetings").first()
+        # make sure the test is valid
+        assert meetings.left is False
+        # Widgets in private hubs aren't displayed to
+        # anonymous users.
+        with auth_set(self.app.application, None):
+            with self.app.application.app_context():
+                widgets = get_visible_widgets(hub)
+        self.assertEqual(widgets["left"], [])
+        self.assertEqual(widgets["right"], [])
+        # But they are displayed to members.
+        with auth_set(self.app.application, FakeAuthorization('ralph')):
+            with self.app.application.app_context():
+                widgets = get_visible_widgets(hub)
+        self.assertNotEqual(len(widgets["left"]), 0)
+        self.assertNotEqual(len(widgets["right"]), 0)
diff --git a/hubs/tests/test_widgets/__init__.py b/hubs/tests/test_widgets/__init__.py
index 3297022..7d171e4 100644
--- a/hubs/tests/test_widgets/__init__.py
+++ b/hubs/tests/test_widgets/__init__.py
@@ -1,13 +1,16 @@
 from __future__ import unicode_literals
 
 import json
+import unittest
 
 import hubs.models
-from hubs.tests import APPTest
+from hubs.tests import APPTest, FakeAuthorization
 
 
 class WidgetTest(APPTest):
 
+    plugin = None  # The name in hubs.widgets.registry
+
     def populate(self):
         super(WidgetTest, self).populate()
         hub = hubs.models.Hub.by_name('ralph')
@@ -18,4 +21,27 @@ class WidgetTest(APPTest):
             _config=json.dumps({"urls": "ralph/"})
         )
         hub.widgets.append(widget)
-        hubs.app.session.commit()
+        self.session.commit()
+
+    def _test_view_authz(self):
+        # Test authorizations on the root view.
+        if not self.plugin:
+            raise unittest.SkipTest
+        hub = hubs.models.Hub.query.get("ralph")
+        widget = self.widget_instance(hub.name, self.plugin)
+        url = '/%s/w/%s/%i/' % (hub.name, self.plugin, widget.idx)
+        # Public
+        self.check_url(url, None, 200)
+        # Preview
+        hub.config.visibility = "preview"
+        widget.visibility = "restricted"
+        self.session.commit()
+        self.check_url(url, None, 403)  # anonymous
+        self.check_url(url, FakeAuthorization('decause'), 200)  # logged-in
+        # Private
+        widget.hub.config.visibility = "private"
+        self.session.commit()
+        self.check_url(url, None, 403)  # anonymous
+        self.check_url(url, FakeAuthorization('decause'), 403)  # logged-in
+        hub.subscribe(hubs.models.User.query.get("decause"), "member")
+        self.check_url(url, FakeAuthorization('decause'), 200)  # member
diff --git a/hubs/tests/test_widgets/test_about.py b/hubs/tests/test_widgets/test_about.py
index edab332..dd00e20 100644
--- a/hubs/tests/test_widgets/test_about.py
+++ b/hubs/tests/test_widgets/test_about.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 import json
 
-from hubs.tests import FakeAuthorization, auth_set
-from hubs.tests.test_widgets import WidgetTest
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
 
 
 class TestAbout(WidgetTest):
@@ -12,12 +12,13 @@ class TestAbout(WidgetTest):
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
         user = FakeAuthorization('ralph')
-        with auth_set(self.app.application, user):
-            response = self.app.get('/ralph/%i/json' % widget.idx)
-        self.assertEqual(response.status_code, 200)
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
             'text': 'Testing.',
             'title': "<span class='glyphicon glyphicon-info-sign' "
                      "aria-hidden='true'></span> About",
         })
+
+    def test_view_authz(self):
+        self._test_view_authz()
diff --git a/hubs/tests/test_widgets/test_badges.py b/hubs/tests/test_widgets/test_badges.py
index 30284fd..3cd2ee2 100644
--- a/hubs/tests/test_widgets/test_badges.py
+++ b/hubs/tests/test_widgets/test_badges.py
@@ -3,8 +3,8 @@ from __future__ import unicode_literals
 import json
 
 import hubs.widgets
-from hubs.tests import FakeAuthorization, auth_set
-from hubs.tests.test_widgets import WidgetTest
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
 
 
 class TestBadges(WidgetTest):
@@ -13,9 +13,7 @@ class TestBadges(WidgetTest):
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
         user = FakeAuthorization('ralph')
-        with auth_set(self.app.application, user):
-            response = self.app.get('/ralph/%i/json' % widget.idx)
-        self.assertEqual(response.status_code, 200)
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
         data = json.loads(response.get_data(as_text=True))
         self.assertEquals(data['plugin'], 'badges')
         self.assertIn('assertions', data['data'].keys())
@@ -58,3 +56,6 @@ class TestBadges(WidgetTest):
         func = module.get_cached_functions()['GetBadges']
         result = func(widget).should_invalidate(msg)
         self.assertTrue(result)
+
+    def test_view_authz(self):
+        self._test_view_authz()
diff --git a/hubs/tests/test_widgets/test_contact.py b/hubs/tests/test_widgets/test_contact.py
index 3e63953..3d885d1 100644
--- a/hubs/tests/test_widgets/test_contact.py
+++ b/hubs/tests/test_widgets/test_contact.py
@@ -7,8 +7,8 @@ import mock
 
 import hubs
 from hubs.models import Hub, Widget
-from hubs.tests import APPTest, FakeAuthorization, auth_set
-from hubs.tests.test_widgets import WidgetTest
+from hubs.tests import FakeAuthorization, auth_set
+from . import WidgetTest
 
 
 def mocked_requests_get(*args, **kwargs):
@@ -56,7 +56,7 @@ def mocked_requests_post(*args, **kwargs):
     return MockResponse({}, 404)
 
 
-class ContactsTest(APPTest):
+class ContactsTest(WidgetTest):
 
     plugin = "contact"
 
@@ -74,9 +74,7 @@ class ContactsTest(APPTest):
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
         user = FakeAuthorization('ralph')
-        with auth_set(self.app.application, user):
-            response = self.app.get('/ralph/%i/json' % widget.idx)
-        self.assertEqual(response.status_code, 200)
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
             'account_age': 'Oct 2010',
@@ -89,6 +87,9 @@ class ContactsTest(APPTest):
             'usergroup': True,
         })
 
+    def test_view_authz(self):
+        self._test_view_authz()
+
     @mock.patch('requests.get', side_effect=mocked_requests_get)
     def test_plus_plus_get_valid(self, mock_get):
         widget = self.widget_instance("ralph", self.plugin)
diff --git a/hubs/tests/test_widgets/test_fedmsgstats.py b/hubs/tests/test_widgets/test_fedmsgstats.py
index 4861b49..87b5ae0 100644
--- a/hubs/tests/test_widgets/test_fedmsgstats.py
+++ b/hubs/tests/test_widgets/test_fedmsgstats.py
@@ -2,8 +2,8 @@ from __future__ import unicode_literals
 
 import json
 
-from hubs.tests import FakeAuthorization, auth_set
-from hubs.tests.test_widgets import WidgetTest
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
 
 
 class TestFedmsgStats(WidgetTest):
@@ -12,9 +12,7 @@ class TestFedmsgStats(WidgetTest):
     def test_data_simple(self):
         widget = self.widget_instance('ralph', self.plugin)
         user = FakeAuthorization('ralph')
-        with auth_set(self.app.application, user):
-            response = self.app.get('/ralph/%i/json' % widget.idx)
-        self.assertEqual(response.status_code, 200)
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
         data = json.loads(response.get_data(as_text=True))
         self.assertDictEqual(data['data'], {
             u'fedmsgs': 83854,
@@ -27,3 +25,6 @@ class TestFedmsgStats(WidgetTest):
             u'hub_subscribe_url': u'/api/hub/ralph/subscribe',
             u'hub_unsubscribe_url': u'/api/hub/ralph/unsubscribe',
         })
+
+    def test_view_authz(self):
+        self._test_view_authz()
